################################################################################
# Project   : CorSight2 FPGA
# Title     : PCIe x1 timing constraints file
################################################################################
# Copyright (c) 2017 NET New Electronic Technology GmbH
################################################################################

###############################################################################
# Physical Constraints
###############################################################################
# PCIe Lane 0
set_property LOC GTPE2_CHANNEL_X0Y7 [get_cells -hierarchical -filter {NAME =~ */inst/gt_top_i/pipe_wrapper_i/pipe_lane[0].gt_wrapper_i/gtp_channel.gtpe2_channel_i}]

# PCIe Lane 1
#set_property LOC GTPE2_CHANNEL_X0Y6 [get_cells -hierarchical -filter {NAME =~ */inst/gt_top_i/pipe_wrapper_i/pipe_lane[1].gt_wrapper_i/gtp_channel.gtpe2_channel_i}]

# GTP Common Placement
set_property LOC GTPE2_COMMON_X0Y1 [get_cells -hierarchical -filter {NAME =~ */inst/gt_top_i/pipe_wrapper_i/pipe_lane[0].pipe_quad.gt_common_enabled.gt_common_int.gt_common_i/qpll_wrapper_i/gtp_common.gtpe2_common_i}]

# PCI Express Block placement. This constraint selects the PCI Express Block to be used.
#set_property LOC PCIE_X0Y0 [get_cells -hierarchical -filter {NAME =~ */inst/pcie_top_i/pcie_7x_i/pcie_block_i]

# PCIe Clock Buffer placement
set_property LOC IBUFDS_GTE2_X0Y2 [get_cells -hierarchical -filter {NAME =~ */PcieInst/PcieCoreInst/PcieRefClkBuf}]

# BlockRAM placement
set_property LOC RAMB36_X2Y36 [get_cells -hierarchical -filter {NAME =~ */inst/pcie_top_i/pcie_7x_i/pcie_bram_top/pcie_brams_rx/brams[3].ram/use_tdp.ramb36/ramb_bl.ramb36_dp_bl.ram36_bl}]
set_property LOC RAMB36_X1Y37 [get_cells -hierarchical -filter {NAME =~ */inst/pcie_top_i/pcie_7x_i/pcie_bram_top/pcie_brams_rx/brams[2].ram/use_tdp.ramb36/ramb_bl.ramb36_dp_bl.ram36_bl}]
set_property LOC RAMB36_X1Y36 [get_cells -hierarchical -filter {NAME =~ */inst/pcie_top_i/pcie_7x_i/pcie_bram_top/pcie_brams_rx/brams[1].ram/use_tdp.ramb36/ramb_bl.ramb36_dp_bl.ram36_bl}]
set_property LOC RAMB36_X1Y35 [get_cells -hierarchical -filter {NAME =~ */inst/pcie_top_i/pcie_7x_i/pcie_bram_top/pcie_brams_rx/brams[0].ram/use_tdp.ramb36/ramb_bl.ramb36_dp_bl.ram36_bl}]
set_property LOC RAMB36_X1Y34 [get_cells -hierarchical -filter {NAME =~ */inst/pcie_top_i/pcie_7x_i/pcie_bram_top/pcie_brams_tx/brams[0].ram/use_tdp.ramb36/ramb_bl.ramb36_dp_bl.ram36_bl}]
set_property LOC RAMB36_X1Y33 [get_cells -hierarchical -filter {NAME =~ */inst/pcie_top_i/pcie_7x_i/pcie_bram_top/pcie_brams_tx/brams[1].ram/use_tdp.ramb36/ramb_bl.ramb36_dp_bl.ram36_bl}]
set_property LOC RAMB36_X1Y32 [get_cells -hierarchical -filter {NAME =~ */inst/pcie_top_i/pcie_7x_i/pcie_bram_top/pcie_brams_tx/brams[2].ram/use_tdp.ramb36/ramb_bl.ramb36_dp_bl.ram36_bl}]
set_property LOC RAMB36_X1Y31 [get_cells -hierarchical -filter {NAME =~ */inst/pcie_top_i/pcie_7x_i/pcie_bram_top/pcie_brams_tx/brams[3].ram/use_tdp.ramb36/ramb_bl.ramb36_dp_bl.ram36_bl}]

###############################################################################
# Timing Constraints (already defined in CS2_Rev1_FPGA_Constraints_RTL.xdc)
###############################################################################
# create_clock -period 10.0 -name TS_PCI_CLK -waveform {0.0 5.0} [get_ports Pcie_RefClkPxCI]
# create_clock -name txoutclk_x0y0 -period 10 [get_pins -hierarchical -filter {NAME=~*/inst/gt_top_i/pipe_wrapper_i/pipe_lane[0].gt_wrapper_i/gtp_channel.gtpe2_channel_i/TXOUTCLK}]
# 
# create_generated_clock -name clk_125mhz_x0y0 [get_pins -hierarchical -filter {NAME =~ */pipe_clock_i/mmcm_i/CLKOUT0}]
# create_generated_clock -name clk_250mhz_x0y0 [get_pins -hierarchical -filter {NAME =~ */pipe_clock_i/mmcm_i/CLKOUT1}]
# create_generated_clock -name clk_125mhz_mux_x0y0 -source [get_pins -hierarchical -filter {NAME =~ */pipe_clock_i/pclk_i1_bufgctrl.pclk_i1/I0}] -divide_by 1 [get_pins -hierarchical -filter {NAME =~ */pipe_clock_i/pclk_i1_bufgctrl.pclk_i1/O}]
# create_generated_clock -name clk_250mhz_mux_x0y0 -source [get_pins -hierarchical -filter {NAME =~ */pipe_clock_i/pclk_i1_bufgctrl.pclk_i1/I1}] -divide_by 1 -add -master_clock clk_250mhz_x0y0 [get_pins -hierarchical -filter {NAME =~ */pipe_clock_i/pclk_i1_bufgctrl.pclk_i1/O}]
# 
# set_clock_groups -name pcieclkmux -physically_exclusive -group clk_125mhz_mux_x0y0 -group clk_250mhz_mux_x0y0

###############################################################################
# Asynchronous Paths
###############################################################################
set_false_path -to [get_pins -hierarchical -filter {NAME =~ */pipe_clock_i/pclk_i1_bufgctrl.pclk_i1/S0}]
set_false_path -to [get_pins -hierarchical -filter {NAME =~ */pipe_clock_i/pclk_i1_bufgctrl.pclk_i1/S1}]

set_false_path -through [get_pins -hierarchical -filter {NAME=~*/inst/pcie_top_i/pcie_7x_i/pcie_block_i/PLPHYLNKUPN}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/inst/pcie_top_i/pcie_7x_i/pcie_block_i/PLRECEIVEDHOTRST}]

set_false_path -through [get_pins -hierarchical -filter {NAME=~*/RXELECIDLE}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/TXPHINITDONE}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/TXPHALIGNDONE}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/TXDLYSRESETDONE}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/RXDLYSRESETDONE}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/RXPHALIGNDONE}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/RXCDRLOCK}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/CFGMSGRECEIVEDPMETO}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/PLL0LOCK}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/RXPMARESETDONE}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/RXSYNCDONE}]
set_false_path -through [get_pins -hierarchical -filter {NAME=~*/TXSYNCDONE}]
