-------------------------------------------------------------------------------
-- Project    : CorSight2 - Custom Module
-- Title      : USER Design TestBench Configuration
-------------------------------------------------------------------------------
-- Copyright (c) 2017 NET New Electronic Technology GmbH
-------------------------------------------------------------------------------
-- Revisions  : Date        Version  Author   Description
--              2017-10-19  1.0      Manfred  Created
-------------------------------------------------------------------------------

library work;
use work.SimCfg.all;

package CfgModule is
    -- Select USER Design initialization file
    constant cTB_INI_FILE     : string := cSIM_ROOT_DIR & "TestBench_User.ini";

    -- Select DDR3 simulation model
    type tDDR3_SIM_PART is (NONE, MT41K64M16XX107, CUSTOM_RAM);

    constant cDDR3_SIM_ID     : tDDR3_SIM_PART := CUSTOM_RAM;       -- Select DDR3-RAM type
    constant cCUSTOM_RAM_SIZE : integer        := 65536;            -- Size of CustomRAM memory [128-bit words]

end CfgModule;
