//------------------------------------------------------------------------------
// File Name         :  $RCSfile:  $
// Author            :  $Author:  $
// Revision          :  $Revision:  $
// Last Modification :  $Date:  $
//------------------------------------------------------------------------------
//                                                  __________
//                                    _            / ________ \ 
//                                   | |          / /    ___ \ \ 
//                                   | |         / /    |__ \ \ \ 
//                                   | |        / /     __ \ \ \ \ 
//           ________     ________   | |____   /_/ __  /  \ \ \ \ \ 
//          / ______ \   / ______ \  |  ____|      \ \ \__/ / / / /
//         | |      | | | |  ____| | | |            \ \____/ / / /
//         | |      | | | | |_____/  | |             \______/ / /
//         | |      | | | |________  | |________         ____/ /
//         |_|      |_|  \_________|  \_________|       |_____/
//
//                                    NEW ELECTRONIC TECHNOLOGY
//
//------------------------------------------------------------------------------
//
// Copyright (C) 2013 NET GmbH All Rights Reserved.
//
// This document, and its contents are the property of NET GmbH.
// NET GmbH retains all rights to: this document, the document contents,
// and the design techniques expressed by the document contents.
// Neither this document, nor any of the information, nor any of the design
// techniques expressed within may be, either in whole or in part: used,
// reproduced, copied, stored, or conveyed to a third party by any means
// without the express written consent of an authorized representative of
// NET GmbH.
//
//------------------------------------------------------------------------------
// Module     : rstbuf
// Submodules : non
//
// Purpose    : reset buffer
//
// Creator    : Jens Wallner
//------------------------------------------------------------------------------
`timescale 1 ns / 1 ps


module rstbuf2 (
    // system signals
    sys_clk,
    sys_rst_n,
    img_rst_n,

    // system signals (modul intern)
    sys_int_clk,
    sys_int_rst_n,
    img_int_rst_n
  );

  //----------------------------------------------------------------------------
  // port declaration
  //----------------------------------------------------------------------------
  //--------------------------------------------------------
  // system signals
  //--------------------------------------------------------
  input           sys_clk;              // system clock
  input           sys_rst_n;            // asynchron low active reset
  input           img_rst_n;            // asynchron low active reset

  //--------------------------------------------------------
  // system signals (modul intern)
  //--------------------------------------------------------
  output          sys_int_clk;          // system clock
  output          sys_int_rst_n;        // asynchron low active reset
  output          img_int_rst_n;        // asynchron low active reset

  //----------------------------------------------------------------------------
  // ADL automatically generated (DO NOT EDIT ANY LINES ABOVE)
  //----------------------------------------------------------------------------

  assign          sys_int_clk = sys_clk;
  reg             sys_int_rst_n;
  reg             img_int_rst_n;
  
  always @(posedge sys_clk or negedge sys_rst_n) begin
    if (!sys_rst_n) sys_int_rst_n <= 1'd0;
    else            sys_int_rst_n <= 1'd1;
  end

  always @(posedge sys_clk or negedge img_rst_n) begin
    if (!img_rst_n) img_int_rst_n <= 1'd0;
    else            img_int_rst_n <= 1'd1;
  end

endmodule
