-- ------------------------------------------------------------------------------
-- File Name         :  $RCSfile:  $
-- Author            :  $Author:  $
-- Revision          :  $Revision:  $
-- Last Modification :  $Date:  $
-- ------------------------------------------------------------------------------
--                                                 __________
--                                   _            / ________ \ 
--                                  | |          / /    ___ \ \ 
--                                  | |         / /    |__ \ \ \ 
--                                  | |        / /     __ \ \ \ \ 
--          ________     ________   | |____   /_/ __  /  \ \ \ \ \ 
--         / ______ \   / ______ \  |  ____|      \ \ \__/ / / / /
--        | |      | | | |  ____| | | |            \ \____/ / / /
--        | |      | | | | |_____/  | |             \______/ / /
--        | |      | | | |________  | |________         ____/ /
--        |_|      |_|  \_________|  \_________|       |_____/
--
--                                   NEW ELECTRONIC TECHNOLOGY
--
-- ------------------------------------------------------------------------------
--
-- Copyright (C) 2014 NET GmbH All Rights Reserved.
--
-- This document, and its contents are the property of NET GmbH.
-- NET GmbH retains all rights to: this document, the document contents,
-- and the design techniques expressed by the document contents.
-- Neither this document, nor any of the information, nor any of the design
-- techniques expressed within may be, either in whole or in part: used,
-- reproduced, copied, stored, or conveyed to a third party by any means
-- without the express written consent of an authorized representative of
-- NET GmbH.
--
-- ------------------------------------------------------------------------------
-- Module     : diffpic_cm_gpio_pkg
-- Submodules : non
--
-- Purpose    :
--
-- Creator    : a.kramer
-- ------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;


package diffpic_cm_gpio_pkg is

  constant NUM_CM_GPIO_IN:   integer := 6;
  constant NUM_CM_GPIO_OUT:  integer := 6;
  constant CM_GPIO_OUT_CTRL: std_logic_vector(NUM_CM_GPIO_OUT-1 downto 0) := "000011";

  constant DEV_ID:           std_logic_vector (31 downto 0) := x"4450494f";
  --constant MEM_SIZE:         std_logic_vector (29 downto 0) := "00" & x"0140000";    -- picture size: 1280*1024
  constant MEM_SIZE:         std_logic_vector (29 downto 0) := "00" & x"04CE300";    -- picture size: 2592*1944 
                            
  constant NOP:              std_logic_vector(2 downto 0) := "000";
  constant SOF:              std_logic_vector(2 downto 0) := "001";
  constant SOSLF:            std_logic_vector(2 downto 0) := "010";
  constant SOD:              std_logic_vector(2 downto 0) := "011";
  constant SOL:              std_logic_vector(2 downto 0) := "100";
  constant SOLL:             std_logic_vector(2 downto 0) := "101";
  constant EOL:              std_logic_vector(2 downto 0) := "110";
  constant ERR:              std_logic_vector(2 downto 0) := "111";
end package diffpic_cm_gpio_pkg;