################################################################################
# Project   : CorSight2 
# Title     : Vivado FPGA debug project file
# Copyright (c) 2017 NET New Electronic Technology GmbH
################################################################################

# Set FPGA compilation environment variables
set Cs2OpenCamDir $TCL_SOURCE_DIR
set Cs2CompileDir $CS2_COMPILE_DIR
set Cs2CompIpDir  $Cs2CompileDir/IP

if {$CUSTOM_COMPILE_MODE == "DEBUG"} {
    if {$CUSTOM_DEBUG_MODULE == "ANALYZER"} {
        if {$CUSTOM_DEBUG_DEVICE == "ILA1x128x1024"} {
            file mkdir       "$Cs2CompIpDir/LogicAnalyzer1x128x1024"
            file copy -force "$Cs2OpenCamDir/IP/LogicAnalyzer/LogicAnalyzer1x128x1024_A7_75.xci" "$Cs2CompIpDir/LogicAnalyzer1x128x1024/LogicAnalyzer1x128x1024.xci"
            read_ip          "$Cs2CompIpDir/LogicAnalyzer1x128x1024/LogicAnalyzer1x128x1024.xci"
        }

        if {$CUSTOM_DEBUG_DEVICE == "ILA1x256x1024"} {
            file mkdir       "$Cs2CompIpDir/LogicAnalyzer1x256x1024"
            file copy -force "$Cs2OpenCamDir/IP/LogicAnalyzer/LogicAnalyzer1x256x1024_A7_75.xci" "$Cs2CompIpDir/LogicAnalyzer1x256x1024/LogicAnalyzer1x256x1024.xci"
            read_ip          "$Cs2CompIpDir/LogicAnalyzer1x256x1024/LogicAnalyzer1x256x1024.xci"
        }
    }
    
    if {$CUSTOM_DEBUG_MODULE == "CHIPSCOPE"} {
        file mkdir "$Cs2CompIpDir/ChipScopePro"
        file copy -force "$Cs2OpenCamDir/IP/LogicAnalyzer/Csp_Icon.ngc" "$Cs2CompIpDir/ChipScopePro/Csp_Icon.ngc"
        read_edif "$Cs2CompIpDir/ChipScopePro/Csp_Icon.ngc"
        
        if {$CUSTOM_DEBUG_DEVICE == "ILA1x128x1024"} {
            file copy -force "$Cs2OpenCamDir/IP/LogicAnalyzer/Csp_Ila_1x128x1024.ngc" "$Cs2CompIpDir/ChipScopePro/Csp_Ila_1x128x1024.ngc"
            read_edif "$Cs2CompIpDir/ChipScopePro/Csp_Ila_1x128x1024.ngc"
        }

        if {$CUSTOM_DEBUG_DEVICE == "ILA1x256x1024"} {
            file copy -force "$Cs2OpenCamDir/IP/LogicAnalyzer/Csp_Ila_1x256x1024.ngc" "$Cs2CompIpDir/ChipScopePro/Csp_Ila_1x256x1024.ngc"
            read_edif "$Cs2CompIpDir/ChipScopePro/Csp_Ila_1x256x1024.ngc"
        }
    }
}